#include <VRS51L3074_SDCC.h>





void initAD(void)
{
int cptr = 0x00;
char readflag = 0x00;

	PERIPHEN1 |= 0xC0; 				//Make sure the SPI Interface is activated
	//--Wait activity stops on the SPI interface (Monitor SPINOCS)
	while(!(SPISTATUS &= 0x08));
	SPICTRL = 0x85;				//SPICLK = /32 (1.25MHz)
								//CS0 Active
								//SPI Mode 0 Phase = 0, POL = 0
								//SPI Master Mode

	SPICONFIG = 0x40;				//SPI Chip select is automatic
								//Clear SPIUNDEFC Flag
								//SPILOAD = 0 -> Manual CS3 behaviour
								//No SPI Interrupt used

	SPISTATUS = 0x00;				//SPI transactions are in MSB First Format

	SPISIZE = 0x17;				        //SPI Transaction Size is 24-bits
	//-Dummy Read the SPI RX buffer to clear the RXAV Flag
	readflag = SPIRXTX0;
}


#define START	(1<<2)
#define SINGLE	(1<<1)

int ReadAD (unsigned char Channel)
{	
int adcdata;

	//-Perform the SPI read
	SPIRXTX2 = 0x00;			
	SPIRXTX1 = (Channel<<6);
	SPIRXTX0 = START | SINGLE | (Channel>>2);		//Writing to the SPIRXTX0 will trigger the SPI Transaction


	//Wait for SPIRXAVF being set
	while(!(SPISTATUS & 0x02));


	//Read SPI data
	adcdata= (SPIRXTX1 << 8);
	adcdata|= SPIRXTX0;
	adcdata&= 0x0FFF;				//isolate the 12 lsb of the read value
	return(adcdata);
}

void main ()
{
int Value;

	initAD();

	while (1){
		Value = ReadAD ( 3 );
	}
}
